<template>
    <v-row justify="center" align="center">
        <v-col xs="11" sm="11" md="10" lg="10" xl="10">
            <v-card class="ma-2 dayContainer pa-5" elevation="4">
                <Header
                    class="mb-5"
                    toRoute="calendar"
                    :showPrevious="!isAddNew"
                    :params="{ edited, displayedDate: removeDay(day) }">
                    <template v-slot:title>
                        <v-card class="text-h4 pa-2 pt-4 pb-4" outlined>
                            {{ formatDay(new Date(day)) }}
                        </v-card>
                    </template>
                    <template v-slot:extra>
                        <v-col cols="2">
                            <v-btn
                                color="primary"
                                fab
                                @click="isAddNew = !isAddNew">
                                <font-awesome-icon
                                    :icon="isAddNew ? 'minus' : 'plus'"
                                    size="2x" />
                            </v-btn>
                        </v-col>
                    </template>
                </Header>
                <v-dialog
                    v-model="dialog"
                    fullscreen
                    hide-overlay
                    transition="dialog-bottom-transition"
                    >
                    <v-img
                        class="uploadedImage"
                        min-height="100%"
                        min-width="100%"
                        aspect-ratio="1"
                        :src="fullScreenImage"
                        @click="dialog = false"/>
                </v-dialog>

                <NewReceipt
                    v-if="isAddNew"
                    @showFullScreen="showFullScreen"
                    @onDone="onDone"
                    :day="day"
                />
                <ReceiptsPerDay
                    v-else
                    :receipts="state.receipts"
                    @showFullScreen="showFullScreen"
                    @remove="remove"
                />
            </v-card>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Component, Inject, Prop, Vue } from 'vue-property-decorator'
import Header from "@/components/Header.vue"
import ReceiptsPerDay from "@/components/ReceiptsPerDay.vue"
import NewReceipt from "@/components/NewReceipt.vue"
import { expenditureTypes, expenditureColors } from "@/utils/categories"
import { formatAmount } from "@/utils/price"
import { formatMonth, removeDay } from "@/utils/date"
import { Observer } from "mobx-vue";
import { DayModel } from "@/store/modules/day";
import { RootStore } from "@/store"
import dayjs from "dayjs"
import { Receipt } from "@/types/calendar"

@Observer
@Component({ components: { Header, NewReceipt, ReceiptsPerDay }})
export default class Day extends Vue {
    public expenditureTypes: Array<string> = expenditureTypes
    @Prop() public day!: string
    private dialog: boolean = false
    private expenditureColors: string[] = expenditureColors
    private fullScreenImage: string = ""
    private isAddNew: boolean = false
    @Inject("root") root !: RootStore
    private state = new DayModel(this.root);
    private loading: boolean = false;
    private edited: boolean = false;

    async mounted() {
        if (this.state.receipts.length === 0) this.loadReceiptsByDay();
    }

    private onDone(receipt: Receipt) {
        this.isAddNew = false;
        this.state.addReceipt(receipt);
        this.edited = true;
    }

    private formatAmount(amount: number) {
        return formatAmount(amount);
    }

    private formatDay(day: Date) {
        const date = day.getDate()
        const month = formatMonth(dayjs(this.day).valueOf())
        if (this.$i18n.locale === 'ja') {
            return month +
                date.toString() + this.$t("chart.day");
        } else {
            return this.$t("chart.day") + day.toString() + ' ' +
            month;
        }
    }

    private showFullScreen(image: string) {
        this.dialog = !this.dialog;
        this.fullScreenImage = image;
    }

    private receiptColor(expenditureType: string) {
        const idx = expenditureTypes.indexOf(expenditureType);
        return this.expenditureColors[idx];
    }

    private async loadReceiptsByDay() {
        const [year, month, day ] = this.day.split("-");
        const start = new Date(Number(year), Number(month) - 1, Number(day), 0, 0, 0).getTime();
        let end = new Date(Number(year), Number(month) - 1, Number(day), 23, 59, 59).getTime();
        this.state.fetchReceipts(start, end);
    }

    private async remove(index: number) {
        await this.state.removeReceipt(index);
        this.edited = true;
    }

    private removeDay(date: string) {
        return removeDay(date)
    }
}

</script>

<style scoped>
.dayContainer {
    width: 100%;
    height: 100%;
}
.uploadedContainer {
    width: 100%;
    height: 100%;
    position: relative;
    display: inline-block;
}

.closeUploaded {
    position: absolute;
    top: 5px;
    left: 5px;
    z-index: 2;

}

.uploadedImage {
    z-index: 1;
    height: 100%;
    width: 100%;
}

.nothingYet {
    color: #878787;
    margin: 50px;
}
</style>
